AppTitle "Pumtris"
Graphics 800, 600, 16, 2
Graphics 640, 480, 16, 3
SetBuffer BackBuffer()
SeedRnd MilliSecs()

imgBlock = LoadImage("block.png")
imgBlock2 = LoadImage("block2.png")
imgBlock3 = LoadImage("block3.png")

imgBack = LoadImage("back.png")
imgField = LoadImage("field.png")

MaskImage imgBlock, 255, 0, 255
MaskImage imgBlock2, 255, 0, 255
MaskImage imgBlock3, 255, 0, 255

MaskImage imgBack, 255, 0, 255
MaskImage imgField, 255, 0, 255

Global pX = 320, pY# = 0, pS = Rand(0, 2), pR = 0
Global pF# = 1, pScore = 0, pLines = 20, pLvl = 1
Global bLeft = False, bRight = False
Global bScore = 0, sTime
Global inTime

Dim place(10, 16)

Font = LoadFont("Verdana", 24, True, False, False)
SetFont Font

While Not KeyDown(1)

DrawImage imgBack, 0, 0
DrawImage imgField, 320 - (ImageWidth(imgField) / 2), 240 - (ImageHeight(imgField) / 2)

bLeft = False
bRight = False

If pS = 0 Then ; Long ----
	tmpX = (px - 200) / 24
	tmpY = (pY - 58) / 24		

	If pR = 0 Then
		DrawImage imgBlock, pX, pY
		DrawImage imgBlock, pX, pY + 24
		DrawImage imgBlock, pX, pY - 24
		DrawImage imgBlock, pX, pY - 48

		If place(tmpX - 1, tmpY) <> 0 Or place(tmpX - 1, tmpY + 1) <> 0 Or place(tmpX - 1, tmpY - 1) <> 0 Or place(tmpX - 1, tmpY - 2) <> 0 Then bLeft = True
		If place(tmpX + 1, tmpY) <> 0 Or place(tmpX + 1, tmpY + 1) <> 0 Or place(tmpX + 1, tmpY - 1) <> 0 Or place(tmpX + 1, tmpY - 2) <> 0 Then bRight = True
							
		If pY + 24 >= 384 Or place(tmpX, tmpY + 2) <> 0 Then 
			place(tmpX, tmpY) = 1
			place(tmpX, tmpY + 1) = 1
			place(tmpX, tmpY - 1) = 1
			place(tmpX, tmpY - 2) = 1
			
			ScanHit
		EndIf
		
	ElseIf pR = 1 Then
		DrawImage imgBlock, pX + 24, pY
		DrawImage imgBlock, pX - 24, pY
		DrawImage imgBlock, pX, pY
		DrawImage imgBlock, pX - 48, pY

		If place(tmpX - 3, tmpY) <> 0  Then bLeft = True
		If place(tmpX + 2, tmpY)  <> 0  Then bRight = True
		
		If pX - 48 <= 200 Then bLeft = True
		If pX + 24 >= 416 Then bRight = True
		
		If pY >= 384 Or place(tmpX, tmpY + 1)  <> 0  Or place(tmpX + 1, tmpY + 1)  <> 0  Or place(tmpX - 1, tmpY + 1)  <> 0  Or place(tmpX - 2, tmpY + 1) <> 0  Then 
			place(tmpX, tmpY) = 1
			place(tmpX + 1, tmpY) = 1
			place(tmpX - 1, tmpY) = 1
			place(tmpX - 2, tmpY) = 1
			
			ScanHit
		EndIf
			
	EndIf
	
ElseIf pS = 1 Then ; Square
	tmpX = (px - 200) / 24
	tmpY = (pY - 58) / 24		

		DrawImage imgBlock2, pX, pY
		DrawImage imgBlock2, pX, pY - 24
		DrawImage imgBlock2, pX - 24, pY - 24
		DrawImage imgBlock2, pX - 24, pY

		If place(tmpX - 2, tmpY)  <> 0  Or place(tmpX - 2, tmpY - 1)  <> 0  Then  bLeft = True
		If place(tmpX + 1, tmpY)  <> 0  Or place(tmpX + 1, tmpY - 1)  <> 0  Then  bRight = True

		If pX - 24 <= 200 Then bLeft = True
		If pX >= 416 Then bRight = True
	
							
		If pY >= 384 Or place(tmpX, tmpY + 1)  <> 0  Or place(tmpX - 1, tmpY + 1)  <> 0  Then 
			place(tmpX, tmpY) = 2
			place(tmpX, tmpY - 1) = 2
			place(tmpX - 1, tmpY - 1) = 2
			place(tmpX - 1, tmpY) = 2
			
			ScanHit
		EndIf

ElseIf pS = 2 Then ; Cross

	tmpX = (px - 200) / 24
	tmpY = (pY - 58) / 24		

	If pR = 0 Then
		DrawImage imgBlock3, pX, pY
		DrawImage imgBlock3, pX, pY - 24
		DrawImage imgBlock3, pX - 24, pY
		DrawImage imgBlock3, pX + 24, pY
	
		If place(tmpX - 2, tmpY)  <> 0  Then  bLeft = True
		If place(tmpX + 2, tmpY) <> 0  Then  bRight = True
	
		If pX - 24 <= 200 Then bLeft = True
		If pX + 24 >= 416 Then bRight = True
		
								
		If pY >= 384 Or place(tmpX, tmpY + 1)  <> 0  Or place(tmpX - 1, tmpY + 1)  <> 0  Or place(tmpX + 1, tmpY + 1)  <> 0  Then 
			place(tmpX, tmpY) = 3
			place(tmpX, tmpY - 1) = 3
			place(tmpX - 1, tmpY) = 3
			place(tmpX + 1, tmpY) = 3
			
			ScanHit
		EndIf
	
	ElseIf pR = 1 Then

		DrawImage imgBlock3, pX, pY
		DrawImage imgBlock3, pX, pY - 24
		DrawImage imgBlock3, pX, pY + 24
		DrawImage imgBlock3, pX + 24, pY
	
		If place(tmpX - 1, tmpY)  <> 0  Then  bLeft = True
		If place(tmpX + 2, tmpY)  <> 0  Then  bRight = True
		If place(tmpX - 1, tmpY - 1)  <> 0  Then  bLeft = True
		If place(tmpX - 1, tmpY + 1)  <> 0  Then  bLeft = True
	
		If pX <= 200 Then bLeft = True
		If pX + 24 >= 416 Then bRight = True
		
								
		If pY + 24 >= 384 Or place(tmpX, tmpY + 2)  <> 0   Or place(tmpX + 1, tmpY + 1)  <> 0  Then 
			place(tmpX, tmpY) = 3
			place(tmpX, tmpY - 1) = 3
			place(tmpX, tmpY + 1) = 3
			place(tmpX + 1, tmpY) = 3
			
			ScanHit
		EndIf

	ElseIf pR = 2 Then

		DrawImage imgBlock3, pX, pY
		DrawImage imgBlock3, pX, pY + 24
		DrawImage imgBlock3, pX - 24, pY
		DrawImage imgBlock3, pX + 24, pY
	
		If place(tmpX - 2, tmpY)  <> 0  Then  bLeft = True
		If place(tmpX + 2, tmpY)  <> 0  Then  bRight = True
	
		If pX - 24 <= 200 Then bLeft = True
		If pX + 24 >= 416 Then bRight = True
		
								
		If pY + 24 >= 384 Or place(tmpX, tmpY + 1)  <> 0  Or place(tmpX - 1, tmpY + 1)  <> 0  Or place(tmpX + 1, tmpY + 1)  <> 0  Or place(tmpX, tmpY + 2)  <> 0  Then 
			place(tmpX, tmpY) = 3
			place(tmpX, tmpY + 1) = 3
			place(tmpX - 1, tmpY) = 3
			place(tmpX + 1, tmpY) = 3
			
			ScanHit
		EndIf

	ElseIf pR = 3 Then

		DrawImage imgBlock3, pX, pY
		DrawImage imgBlock3, pX, pY - 24
		DrawImage imgBlock3, pX, pY + 24
		DrawImage imgBlock3, pX - 24, pY
	
		If place(tmpX - 1, tmpY)  <> 0  Then  bRight = True
		If place(tmpX - 2, tmpY)  <> 0  Then  bLeft = True
		If place(tmpX - 1, tmpY - 1)  <> 0  Then  bRight = True
		If place(tmpX - 1, tmpY + 1)  <> 0 Then  bRight = True
	
		If pX - 24 <= 200 Then bLeft = True
		If pX >= 416 Then bRight = True
		
								
		If pY + 24 >= 384 Or place(tmpX, tmpY + 2)  <> 0   Or place(tmpX - 1, tmpY + 1)  <> 0  Then 
			place(tmpX, tmpY) = 3
			place(tmpX, tmpY - 1) = 3
			place(tmpX, tmpY + 1) = 3
			place(tmpX - 1, tmpY) = 3
			
			ScanHit
		EndIf
								
	EndIf
			
EndIf

For y = 0 To 15
	For x = 0 To 9
		If place(x, y) = 1 Then DrawImage imgBlock, 200 + (x * 24), 48 + (y * 24)
		If place(x, y) = 2 Then DrawImage imgBlock2, 200 + (x * 24), 48 + (y * 24)
		If place(x, y) = 3 Then DrawImage imgBlock3, 200 + (x * 24), 48 + (y * 24)

	Next
Next



tmpPass = False

If MilliSecs() >= inTime + 75 Then
	tmpPass = True
EndIf

	tmpIn = False
	If KeyDown(203) And pX > 200 And bLeft = False Then 
	
		If tmpPass = True
			pX = pX - 24
			inTime = MilliSecs()

		EndIf
		tmpIn = True
		
		
	ElseIf KeyDown(205) And pX < 416 And bRight = False Then 
	
		If tmpPass = True Then
			pX = pX + 24
			inTime = MilliSecs()

		EndIf
		tmpIn = True
		
		
	EndIf

If tmpIn = False Then inTime = MilliSecs() - 75
	
If KeyHit(57) Then 
	If pS = 0 Then
		If pR = 0 Then pR = 1 Else pR = 0
	ElseIf ps = 2 Then
		If pR < 3 Then pR = pR + 1 Else pR = 0
	EndIf
	
EndIf

If KeyDown(208) Then
	pY = pY + (pF + 4)
Else
	pY = pY + pF
EndIf

Color 255, 255, 0
Text 1, 1, pX
Text 1, 16, pY
Text 320 - (StringWidth("Score: " + pScore) / 2), 445, "Score: " + pScore
Text 1, 445, "Lines: " + pLines
Text 1, 420, "Level: " + pLvl

If pLines <= 0 Then 
	pLines = 20
	pF = pF + .5
	pLvl = pLvl + 1
	bScore = 5
	sTime = MilliSecs()	
EndIf

If bScore > 0 Then
	If bScore = 1 Then tmp$ = "Single!"
	If bScore = 2 Then tmp$ = "Double!"
	If bScore = 3 Then tmp$ = "Triple!"
	If bScore = 4 Then tmp$ = "Pumtris!"
	If bScore = 5 Then tmp$ = "Level Up!"
	
	Text 320 - (StringWidth(tmp$) / 2), 20, tmp$
		
	If MilliSecs() >= sTime + 1000 Then
		bScore = 0
	EndIf
EndIf

Flip: Cls
Wend: End

Function ScanHit()

pX = 320
pY# = 0
pS = Rand(0, 2)
pR = 0

tmpScore = 0

For y = 0 To 15
	tmpCheck = True
	For x = 0 To 9
		If place(x, y) = 0 Then tmpCheck = False
	Next
	If tmpCheck = True Then
		tmpScore = tmpScore + 1
		
		For x = 0 To 9
			place(x, y) = 0
		Next
		
		For y2 = y - 1 To 0 Step -1
			For x = 0 To 9
				place(x, y2 + 1) = place(x, y2)
			Next
		Next
		
	EndIf
Next			

If tmpScore = 1 Then pScore = pScore + 100
If tmpScore = 2 Then pScore = pScore + 500
If tmpScore = 3 Then pScore = pScore + 1000
If tmpScore = 4 Then pScore = pScore + 3000

pLines = pLines - tmpScore
bScore = tmpScore
sTime = MilliSecs()

inTime = MilliSecs() - 75
			
End Function